import { Observable } from "rxjs";
import { QueryParams, ResolvedRoute, Route } from "./Config";
import { Injector } from "@angular/core";
export declare type Params = {
    [key: string]: string;
};
export declare class RouteContext {
    constructor(url: string, resolvedRoute: ResolvedRoute);
    private _queryParams;
    readonly queryParams: Observable<QueryParams>;
    readonly outlet: string;
    private _routeParams;
    readonly routeParams: Observable<Params>;
    private _url;
    readonly url: string;
    private _route;
    readonly route: Route;
    private _injector;
    readonly injector: Injector;
    private _active;
    readonly active: boolean;
    readonly queryParamsSnapshot: QueryParams;
    readonly routeParamsSnapshot: QueryParams;
    activate(): void;
    deactivate(): void;
    update(url: string, resolvedRoute: ResolvedRoute): void;
}
