import { Injector } from "@angular/core";
import { Location } from "@angular/common";
import { RouteMatchService } from "./RouteMatchService";
import { Observable } from "rxjs";
import { RouterOutletMap } from "./RouterOutletMap";
import { NavigationExtras, QueryParams } from "./Config";
import { NavigationEvent } from "./RouteEvents";
export declare class Router {
    private outletMap;
    private matchService;
    private location;
    private injector;
    private baseHref;
    private resolvedRoutes;
    private locationSubscription;
    private navigationId;
    private currentContext;
    private navigations;
    private navigating;
    constructor(outletMap: RouterOutletMap, matchService: RouteMatchService, location: Location, injector: Injector, baseHref: string);
    readonly queryParamsSnapshot: QueryParams;
    private _queryParams;
    readonly queryParams: Observable<QueryParams>;
    private _events;
    readonly events: Observable<NavigationEvent>;
    private static stripTrailingSlash;
    private static urlEquals;
    initialNavigation(): void;
    navigateByUrl(url: string, extras?: NavigationExtras, params?: QueryParams): Promise<any>;
    reload(): Promise<boolean>;
    setQuery(p: QueryParams, navigationExtras?: NavigationExtras): Promise<any>;
    setUpLocationChangeListener(): void;
    updateQuery(p: QueryParams, navigationExtras?: NavigationExtras): Promise<any>;
    private checkDeactivate;
    private checkGuards;
    private executeScheduledNavigation;
    private matchRoute;
    private navigateInternal;
    private processNavigations;
    private resetUrlToCurrent;
    private resolveRoute;
    private scheduleNavigation;
}
