import { BehaviorSubject, of, Subject, from } from 'rxjs';
import { concatMap, delay, merge } from 'rxjs/operators';
import { __extends, __read, __values, __assign } from 'tslib';
import { APP_BASE_HREF, Location, LocationStrategy, PlatformLocation, CommonModule } from '@angular/common';
import { Injectable, NgModuleFactoryLoader, InjectionToken, Compiler, ComponentFactoryResolver, Injector, Inject, Optional, Attribute, Component, EventEmitter, Input, Output, ViewChild, ViewContainerRef, Directive, NgModule, APP_BOOTSTRAP_LISTENER, ApplicationRef, ANALYZE_FOR_ENTRY_COMPONENTS, SystemJsNgModuleLoader } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
/**
 * @abstract
 */
var  /**
 * @abstract
 */
RouterModuleFactory = /** @class */ (function () {
    function RouterModuleFactory() {
    }
    return RouterModuleFactory;
}());
var DefaultRouterModuleFactory = /** @class */ (function (_super) {
    __extends(DefaultRouterModuleFactory, _super);
    function DefaultRouterModuleFactory(loader) {
        var _this = _super.call(this) || this;
        _this.loader = loader;
        _this.loaded = {};
        return _this;
    }
    /**
     * @param {?} moduleName
     * @param {?} parentInjector
     * @return {?}
     */
    DefaultRouterModuleFactory.prototype.getModule = /**
     * @param {?} moduleName
     * @param {?} parentInjector
     * @return {?}
     */
    function (moduleName, parentInjector) {
        var _this = this;
        if (this.loaded[moduleName]) {
            return Promise.resolve(this.loaded[moduleName]);
        }
        return this.loader.load(moduleName).then(function (factory) {
            return _this.loaded[moduleName] = factory.create(parentInjector);
        });
    };
    DefaultRouterModuleFactory.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    DefaultRouterModuleFactory.ctorParameters = function () { return [
        { type: NgModuleFactoryLoader }
    ]; };
    return DefaultRouterModuleFactory;
}(RouterModuleFactory));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
var UrlParser = /** @class */ (function () {
    function UrlParser() {
    }
    /**
     * @return {?}
     */
    UrlParser.ensureParser = /**
     * @return {?}
     */
    function () {
        if (!UrlParser.parser) {
            UrlParser.parser = document.createElement("a");
        }
    };
    /**
     * @param {?} url
     * @return {?}
     */
    UrlParser.parseUrl = /**
     * @param {?} url
     * @return {?}
     */
    function (url) {
        UrlParser.ensureParser();
        UrlParser.parser.href = url;
        // Host, Hostname, Port Protocol могут быть пучтыми в IE на относительных URL
        /** @type {?} */
        var parseResult = {
            hash: UrlParser.parser.hash,
            host: UrlParser.parser.host,
            hostname: UrlParser.parser.hostname,
            pathname: UrlParser.parser.pathname[0] == "/" ? UrlParser.parser.pathname : "/" + UrlParser.parser.pathname,
            //IE FIX
            port: UrlParser.parser.port,
            protocol: UrlParser.parser.protocol,
            search: UrlParser.parser.search
        };
        UrlParser.parser.href = "";
        return parseResult;
    };
    UrlParser.parser = null;
    return UrlParser;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
/**
 * @param {?} url
 * @param {?} route
 * @return {?}
 */
function defaultRouteMatcher(url, route) {
    //drop query string for matching
    url = UrlParser.parseUrl(url).pathname;
    /** @type {?} */
    var parsedRoute = parseRoute(route.path);
    /** @type {?} */
    var parsedUrl = url.match(parsedRoute.regexp);
    if (parsedUrl) {
        /** @type {?} */
        var params = {};
        for (var i = 0; i < parsedRoute.paramsMap.length; i++) {
            params[parsedRoute.paramsMap[i].name] = parsedUrl[1 + i];
        }
        return Promise.resolve({
            component: route.component,
            params: params,
            route: route
        });
    }
    return Promise.resolve(null);
}
/**
 * Normalizes the given route template string, returning a regular expression representing a route
 * and the original path string.
 *
 * Inspired by pathRexp in visionmedia/express/lib/utils.js.
 * and angular/angular.js/blob/master/src/ngRoute/route.js
 * @param {?} routeUrl
 * @return {?}
 */
function parseRoute(routeUrl) {
    /** @type {?} */
    var params = [];
    /** @type {?} */
    var result = {
        path: routeUrl,
        regexp: null,
        paramsMap: params
    };
    /* since our route table does not apply prefixes to url via forChild
     *  we should assume all routes start from root */
    if (routeUrl[0] !== "/") {
        routeUrl = "/" + routeUrl;
    }
    /** @type {?} */
    var path = routeUrl
        .replace(/([().])/g, "\\$1") // escape round brackets and dot with backslash
        .replace(/(\/)?:(\w+)(\*\?|[?*])?/g, function (_, slash, key, option) {
        // find parameters and    wildcards in string
        /** @type {?} */
        var optional = (option === "?" || option === "*?") ? "?" : null;
        /** @type {?} */
        var star = (option === "*" || option === "*?") ? "*" : null;
        params.push({ name: key, optional: !!optional });
        slash = slash || "";
        return ""
            + (optional ? "" : slash)
            + "(?:"
            + (optional ? slash : "")
            + (star && "(.+?)" || "([^/]+)")
            + (optional || "")
            + ")"
            + (optional || "");
    })
        .replace(/([/$*])/g, "\\$1");
    result.regexp = new RegExp("^" + path + "\/?$"); // support trailing slash
    return result;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
/** @type {?} */
var ROUTE_CONFIG = new InjectionToken("router ex route config");
/** @enum {number} */
var ReuseRouteStrategy = {
    /**
     * Create only one instance of route component and allways reuse them
     */
    STICKY: 1,
    /**
     * Reuse route component only when use return on the route by history pop event
     */
    CACHEBACK: 2,
};
ReuseRouteStrategy[ReuseRouteStrategy.STICKY] = 'STICKY';
ReuseRouteStrategy[ReuseRouteStrategy.CACHEBACK] = 'CACHEBACK';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
/**
 * @param {?} loader
 * @param {?} parentInjector
 * @param {?} compiler
 * @param {?} resolve
 * @return {?}
 */
function createAsyncMatcher(loader, parentInjector, compiler, resolve) {
    return function (url, route) {
        if (!route.loadModule) {
            throw new Error("not an async route");
        }
        if (route.loadModuleCondition && !route.loadModuleCondition(url)) {
            return Promise.resolve(null); // don't need to load child module for specified url
        }
        if (typeof route.loadModule === "string") {
            return loader.getModule((/** @type {?} */ (route.loadModule)), parentInjector).then(function (ref) {
                return resolve(ref.injector.get(ROUTE_CONFIG), ref.injector, ref.componentFactoryResolver);
            });
        }
        else {
            /** @type {?} */
            var offlineMode_1 = compiler instanceof Compiler;
            /** @type {?} */
            var loadModule = (/** @type {?} */ (route.loadModule));
            return loadModule()
                .then(function (module) {
                return offlineMode_1 ? module : compiler.compileModuleAsync((/** @type {?} */ (module)));
            })
                .then(function (factory) {
                /** @type {?} */
                var ref = factory.create(parentInjector);
                return resolve(ref.injector.get(ROUTE_CONFIG), ref.injector, ref.componentFactoryResolver);
            });
        }
    };
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
/** @type {?} */
var ERROR_PAGE_PATH = "##";
/** @type {?} */
var NOTFOUND_PAGE_PATH = "**";
var RouteMatchService = /** @class */ (function () {
    function RouteMatchService(resolver, injector, moduleLoader, compiler) {
        this.resolver = resolver;
        this.injector = injector;
        this.moduleLoader = moduleLoader;
        this.compiler = compiler;
    }
    /**
     * @param {?} url
     * @param {?} routes
     * @return {?}
     */
    RouteMatchService.prototype.findRoute = /**
     * @param {?} url
     * @param {?} routes
     * @return {?}
     */
    function (url, routes) {
        return this.resolveInternal(url, routes, this.injector, this.resolver);
    };
    /**
     * @param {?} url
     * @param {?} routes
     * @param {?} injector
     * @param {?} resolver
     * @return {?}
     */
    RouteMatchService.prototype.resolveInternal = /**
     * @param {?} url
     * @param {?} routes
     * @param {?} injector
     * @param {?} resolver
     * @return {?}
     */
    function (url, routes, injector, resolver) {
        var _this = this;
        return new Promise(function (resolve) {
            if (url[0] !== "/") {
                url = "/" + url;
            }
            /** @type {?} */
            var index = 0;
            /** @type {?} */
            var processNext = function () {
                /** @type {?} */
                var matcher = _this.createMatcher(url, routes[index], injector);
                matcher(url, routes[index])
                    .then(function (result) {
                    if (!result) {
                        index++;
                        if (index >= routes.length) {
                            /** @type {?} */
                            var defaultRoute = routes.find(function (r) { return r.path === NOTFOUND_PAGE_PATH; });
                            if (defaultRoute) {
                                /** @type {?} */
                                var notFoundResult = {
                                    route: defaultRoute,
                                    component: defaultRoute.component,
                                    injector: _this.injector,
                                    factoryResolver: _this.resolver,
                                    params: {}
                                };
                                resolve(notFoundResult); // no route found
                            }
                            else {
                                resolve(null);
                            }
                        }
                        else {
                            processNext();
                        }
                    }
                    else {
                        // from async modules matcher can return already resolved routes,
                        // if it is so, use original route from nested resolved route,
                        // not the original form top-level.
                        /** @type {?} */
                        var route = result.route || routes[index];
                        resolve({
                            params: result.params,
                            component: result.component,
                            factoryResolver: result.factoryResolver || resolver,
                            injector: result.injector || injector,
                            route: route
                        });
                    }
                }, function (err) {
                    /** @type {?} */
                    var errorRoute = routes.find(function (r) { return r.path === ERROR_PAGE_PATH; });
                    if (errorRoute) {
                        /** @type {?} */
                        var errorResult = {
                            route: errorRoute,
                            component: errorRoute.component,
                            injector: _this.injector,
                            factoryResolver: _this.resolver,
                            params: {},
                            noCache: true
                        };
                        resolve(errorResult); // no route found
                    }
                    else {
                        resolve(null);
                    }
                    console.error(err);
                });
            };
            processNext();
        });
    };
    /**
     * @param {?} url
     * @param {?} route
     * @param {?} injector
     * @return {?}
     */
    RouteMatchService.prototype.createMatcher = /**
     * @param {?} url
     * @param {?} route
     * @param {?} injector
     * @return {?}
     */
    function (url, route, injector) {
        var _this = this;
        if (route.matcher) {
            return route.matcher;
        }
        return route.loadModule ? createAsyncMatcher(this.moduleLoader, injector, this.compiler, function (loadedRoutes, injector, resolver) { return _this.resolveInternal(url, loadedRoutes, injector, resolver); }) : defaultRouteMatcher;
    };
    RouteMatchService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    RouteMatchService.ctorParameters = function () { return [
        { type: ComponentFactoryResolver },
        { type: Injector },
        { type: RouterModuleFactory },
        { type: Compiler }
    ]; };
    return RouteMatchService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
/** @type {?} */
var PRIMARY_OUTLET = "__router-ex-default";
var RouterOutletMap = /** @class */ (function () {
    function RouterOutletMap() {
        this.map = {};
    }
    /**
     * @param {?} outlet
     * @param {?=} name
     * @return {?}
     */
    RouterOutletMap.prototype.register = /**
     * @param {?} outlet
     * @param {?=} name
     * @return {?}
     */
    function (outlet, name) {
        this.map[name || PRIMARY_OUTLET] = outlet;
    };
    /**
     * @param {?} name
     * @return {?}
     */
    RouterOutletMap.prototype.unregister = /**
     * @param {?} name
     * @return {?}
     */
    function (name) {
        delete this.map[name];
    };
    /**
     * @param {?=} name
     * @return {?}
     */
    RouterOutletMap.prototype.getOutlet = /**
     * @param {?=} name
     * @return {?}
     */
    function (name) {
        return this.map[name || PRIMARY_OUTLET];
    };
    RouterOutletMap.decorators = [
        { type: Injectable }
    ];
    return RouterOutletMap;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
var NavigationStart = /** @class */ (function () {
    function NavigationStart() {
    }
    return NavigationStart;
}());
var NavigationEnd = /** @class */ (function () {
    function NavigationEnd(url, component, routeCtx) {
        this._url = url;
        this._component = component;
        this._routeCtx = routeCtx;
    }
    Object.defineProperty(NavigationEnd.prototype, "url", {
        get: /**
         * @return {?}
         */
        function () {
            return this._url;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NavigationEnd.prototype, "activatedComponent", {
        get: /**
         * @return {?}
         */
        function () {
            return this._component;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NavigationEnd.prototype, "routeContext", {
        get: /**
         * @return {?}
         */
        function () {
            return this._routeCtx;
        },
        enumerable: true,
        configurable: true
    });
    return NavigationEnd;
}());
var NavigationCancel = /** @class */ (function () {
    function NavigationCancel() {
    }
    return NavigationCancel;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
var QueryStringParser = /** @class */ (function () {
    function QueryStringParser() {
    }
    /**
     * @param {?} p
     * @return {?}
     */
    QueryStringParser.serialize = /**
     * @param {?} p
     * @return {?}
     */
    function (p) {
        /** @type {?} */
        var res = [];
        var _loop_1 = function (key) {
            if (p.hasOwnProperty(key)) {
                if (Array.isArray(p[key])) {
                    ((/** @type {?} */ (p[key]))).forEach(function (val) {
                        res.push(key + (val === true ? "" : "=" + encodeURIComponent((/** @type {?} */ (val)))));
                    });
                }
                else {
                    if (!isNullOrUndefined(p[key])) {
                        res.push(key + (p[key] === true ? "" : "=" + encodeURIComponent((/** @type {?} */ (p[key])))));
                    }
                }
            }
        };
        for (var key in p) {
            _loop_1(key);
        }
        return res.join("&");
    };
    /**
     * @param {?} rawQuery
     * @return {?}
     */
    QueryStringParser.parse = /**
     * @param {?} rawQuery
     * @return {?}
     */
    function (rawQuery) {
        /** @type {?} */
        var params = {};
        if (!rawQuery) {
            return params;
        }
        if (rawQuery[0] === '?') {
            rawQuery = rawQuery.substring(1);
        }
        rawQuery.split("&").forEach(function (pair) {
            var _a = __read(pair.split("="), 2), key = _a[0], value = _a[1];
            if (value) {
                try {
                    value = decodeURIComponent(value);
                }
                catch (e) {
                    // drop invalid parameters
                    return;
                }
            }
            if (!params[key]) { // no such key yet
                params[key] = value || true;
            }
            else {
                if (Array.isArray(params[key])) { // value already an array
                    ((/** @type {?} */ (params[key]))).push(value || true);
                }
                else { // make an array
                    params[key] = ((/** @type {?} */ ([params[key], value || true])));
                }
            }
        });
        return params;
    };
    return QueryStringParser;
}());
/**
 * @param {?} obj
 * @return {?}
 */
function isNullOrUndefined(obj) {
    return typeof (obj) === "undefined" || obj === null;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
/**
 * @param {?} pars1
 * @param {?} pars2
 * @param {?=} isRouteParams
 * @return {?}
 */
function isParamsEqual(pars1, pars2, isRouteParams) {
    var e_1, _a;
    /** @type {?} */
    var keys1 = Object.keys(pars1);
    /** @type {?} */
    var keys2 = Object.keys(pars2);
    if (!isRouteParams) {
        // remove parameters with null values
        keys1.forEach(function (k, i) {
            if (pars1[k] === null) {
                delete pars1[k];
                keys1.splice(i, 1);
            }
        });
        keys2.forEach(function (k, i) {
            if (pars2[k] === null) {
                delete pars2[k];
                keys2.splice(i, 1);
            }
        });
    }
    // quantity of parameters mismatch
    if (keys1.length !== keys2.length) {
        return false;
    }
    // different param names
    if (!keys1.every(function (k) { return keys2.indexOf(k) > -1; })) {
        return false;
    }
    var _loop_1 = function (key) {
        if (Array.isArray(pars1[key])) {
            // param is array in one set, not array in another
            if (!Array.isArray(pars2[key])) {
                return { value: false };
            }
            // check nested arrays lengths and values
            if (((/** @type {?} */ (pars1[key]))).length
                == ((/** @type {?} */ (pars2[key]))).length
                && !((/** @type {?} */ (pars1[key]))).every(function (v) { return ((/** @type {?} */ (pars2[key]))).indexOf(v) > -1; })) {
                return { value: false };
            }
        }
        else {
            // check simple non-array values
            if (pars1[key] !== pars2[key]) {
                return { value: false };
            }
        }
    };
    try {
        for (var keys1_1 = __values(keys1), keys1_1_1 = keys1_1.next(); !keys1_1_1.done; keys1_1_1 = keys1_1.next()) {
            var key = keys1_1_1.value;
            var state_1 = _loop_1(key);
            if (typeof state_1 === "object")
                return state_1.value;
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (keys1_1_1 && !keys1_1_1.done && (_a = keys1_1.return)) _a.call(keys1_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    // all checks passed, params sets are equal
    return true;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
var Router = /** @class */ (function () {
    function Router(outletMap, matchService, location, injector, baseHref) {
        this.outletMap = outletMap;
        this.matchService = matchService;
        this.location = location;
        this.injector = injector;
        this.baseHref = baseHref;
        this.resolvedRoutes = {};
        this.navigationId = 0;
        this.navigations = new BehaviorSubject(null);
        this._events = new Subject();
        if (!this.baseHref) {
            this.baseHref = "/";
        }
        this.processNavigations();
    }
    Object.defineProperty(Router.prototype, "queryParamsSnapshot", {
        get: /**
         * @return {?}
         */
        function () {
            return this._queryParams.getValue();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Router.prototype, "queryParams", {
        get: /**
         * @return {?}
         */
        function () {
            return this._queryParams;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Router.prototype, "events", {
        get: /**
         * @return {?}
         */
        function () {
            return this._events;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} url
     * @return {?}
     */
    Router.stripTrailingSlash = /**
     * @param {?} url
     * @return {?}
     */
    function (url) {
        return url[url.length - 1] === "/" ? url.slice(0, -1) : url;
    };
    /**
     * @param {?} url1
     * @param {?} url2
     * @return {?}
     */
    Router.urlEquals = /**
     * @param {?} url1
     * @param {?} url2
     * @return {?}
     */
    function (url1, url2) {
        url1 = Router.stripTrailingSlash(url1);
        url2 = Router.stripTrailingSlash(url2);
        return decodeURIComponent(url1) === decodeURIComponent(url2);
    };
    /**
     * @return {?}
     */
    Router.prototype.initialNavigation = /**
     * @return {?}
     */
    function () {
        this.setUpLocationChangeListener();
        if (this.navigationId === 0) {
            this.navigateByUrl(this.location.path(true), { replaceUrl: true });
        }
    };
    /**
     * @param {?} url
     * @param {?=} extras
     * @param {?=} params
     * @return {?}
     */
    Router.prototype.navigateByUrl = /**
     * @param {?} url
     * @param {?=} extras
     * @param {?=} params
     * @return {?}
     */
    function (url, extras, params) {
        // absolute url
        /** @type {?} */
        var requestedUrl = UrlParser.parseUrl(url);
        if (url.indexOf("https://") === 0 || url.indexOf("http://") === 0 || url.indexOf("//") === 0) {
            if (window.location
                && window.location.host == requestedUrl.host
                && window.location.protocol == requestedUrl.protocol) {
                // это наш хост, выбросим часть маршрута
                url = requestedUrl.pathname + requestedUrl.search + requestedUrl.hash;
            }
            else {
                throw new Error('Router: cannot navigate to external url');
            }
        }
        else if (url[0] !== "/") {
            // add base href
            url = this.baseHref + url;
        }
        if (params) {
            /** @type {?} */
            var _combinedQueryParams = void 0;
            if (requestedUrl.search && requestedUrl.search.length) {
                _combinedQueryParams = __assign({}, QueryStringParser.parse(requestedUrl.search), params);
            }
            else {
                _combinedQueryParams = params;
            }
            url = url.split("?", 1)[0];
            url += "?" + QueryStringParser.serialize(_combinedQueryParams);
        }
        if ((extras && !extras.force) && this.currentContext && url === this.currentContext.url) {
            // navigation within same url
            return Promise.resolve(true);
        }
        // schedule
        return this.navigateInternal(url, extras);
    };
    /**
     * @return {?}
     */
    Router.prototype.reload = /**
     * @return {?}
     */
    function () {
        if (!this.currentContext) {
            return Promise.resolve(false);
        }
        return this.navigateByUrl(this.currentContext.url, { replaceUrl: true, force: true });
    };
    /**
     * @param {?} p
     * @param {?=} navigationExtras
     * @return {?}
     */
    Router.prototype.setQuery = /**
     * @param {?} p
     * @param {?=} navigationExtras
     * @return {?}
     */
    function (p, navigationExtras) {
        if (this.navigating) {
            return Promise.resolve(null);
        }
        /** @type {?} */
        var queryParams = QueryStringParser.serialize(p);
        /** @type {?} */
        var urlParts = UrlParser.parseUrl(this.location.path(true));
        /** @type {?} */
        var newUrl = queryParams.length ? urlParts.pathname + "?" + queryParams : urlParts.pathname;
        return this.navigateByUrl(newUrl, navigationExtras);
    };
    /**
     * @return {?}
     */
    Router.prototype.setUpLocationChangeListener = /**
     * @return {?}
     */
    function () {
        var _this = this;
        // Zone.current.wrap is needed because of the issue with RxJS scheduler,
        // which does not work properly with zone.js in IE and Safari
        if (!this.locationSubscription) {
            this.locationSubscription = (/** @type {?} */ (this.location.subscribe(Zone.current.wrap(function (change) {
                _this.navigateByUrl(change["url"], { replaceUrl: true });
            }))));
        }
    };
    /**
     * @param {?} p
     * @param {?=} navigationExtras
     * @return {?}
     */
    Router.prototype.updateQuery = /**
     * @param {?} p
     * @param {?=} navigationExtras
     * @return {?}
     */
    function (p, navigationExtras) {
        /** @type {?} */
        var existingParams = __assign({}, this.queryParamsSnapshot, p);
        return this.setQuery(existingParams, navigationExtras);
    };
    /**
     * @param {?} currentRoute
     * @param {?} injector
     * @return {?}
     */
    Router.prototype.checkDeactivate = /**
     * @param {?} currentRoute
     * @param {?} injector
     * @return {?}
     */
    function (currentRoute, injector) {
        var e_1, _a;
        if (!currentRoute.canDeactivate) {
            return Promise.resolve(true);
        }
        /** @type {?} */
        var outlet = this.outletMap.getOutlet(currentRoute.outlet);
        /** @type {?} */
        var results = [];
        try {
            for (var _b = __values(currentRoute.canDeactivate), _c = _b.next(); !_c.done; _c = _b.next()) {
                var guardType = _c.value;
                /** @type {?} */
                var guard = (/** @type {?} */ (injector.get(guardType)));
                results.push(guard.canDeactivate(outlet.activatedComponent, currentRoute));
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return Promise.all(results).then(function (all) {
            return !all.some(function (r) { return !r; });
        });
    };
    /**
     * @param {?} newRoute
     * @return {?}
     */
    Router.prototype.checkGuards = /**
     * @param {?} newRoute
     * @return {?}
     */
    function (newRoute) {
        /** @type {?} */
        var deactivation = this.currentContext ? this.checkDeactivate(this.currentContext.route, this.currentContext.injector) : Promise.resolve(true);
        // check deactivation first
        return deactivation.then(function (success) {
            if (!success) {
                return { resolvedRoute: newRoute, success: false };
            }
            // check activation
            return checkActivate(newRoute.route, newRoute.injector).then(function (success) {
                return { resolvedRoute: newRoute, success: success };
            });
        });
    };
    /**
     * @param {?} __0
     * @return {?}
     */
    Router.prototype.executeScheduledNavigation = /**
     * @param {?} __0
     * @return {?}
     */
    function (_a) {
        var _this = this;
        var extras = _a.extras, id = _a.id, url = _a.url;
        /** @type {?} */
        var force = extras && extras.force;
        if (this.currentContext && (!force && Router.urlEquals(url, this.currentContext.url))) {
            // drop same navigation
            return Promise.resolve(true);
        }
        /** @type {?} */
        var shouldReplaceUrl = extras ? extras.replaceUrl : false;
        /** @type {?} */
        var config = this.injector.get(ROUTE_CONFIG);
        this.navigating = true;
        this._events.next(new NavigationStart());
        /** @type {?} */
        var navigationCanceled;
        /** @type {?} */
        var shouldActivate = true;
        /** @type {?} */
        var outlet;
        return this.matchRoute(url, config)
            .then(function (route) { return _this.resolveRoute(url, route); })
            .then(function (resolvedRoute) {
            if (_this.navigationId !== id) {
                // navigation changes while resolving
                navigationCanceled = true;
                return undefined;
            }
            if (_this.currentContext && _this.currentContext.route.path === resolvedRoute.route.path) {
                // navigating with same route
                shouldActivate = force;
                _this.currentContext.update(url, resolvedRoute);
                return { resolvedRoute: resolvedRoute, success: true };
            }
            // set url params to match its parsed state
            if (resolvedRoute.url !== url) {
                url = resolvedRoute.url;
            }
            // check guards if routes changes
            return _this.checkGuards(resolvedRoute);
        })
            .then(function (checkGuardsResult) {
            if (_this.navigationId !== id) {
                // navigation changes while resolving or guard checking
                navigationCanceled = true;
                return _this.currentContext;
            }
            if (checkGuardsResult.success) {
                // we should change location state before activate outlet
                if (shouldReplaceUrl) {
                    _this.location.replaceState(url);
                }
                else {
                    _this.location.go(url);
                }
                outlet = _this.outletMap.getOutlet(checkGuardsResult.resolvedRoute.route.outlet);
                /** @type {?} */
                var resolvedRoute = checkGuardsResult.resolvedRoute;
                if (shouldActivate) {
                    // new route navigation
                    return outlet.activate(resolvedRoute, url, resolvedRoute.component, resolvedRoute.factoryResolver, resolvedRoute.injector, force).then(function (result) { return result.routeContext; });
                }
            }
            else {
                // guard blocked navigation
                _this.resetUrlToCurrent();
                navigationCanceled = true;
            }
            return _this.currentContext;
        })
            .then(function (routeContext) {
            _this.currentContext = routeContext;
        })
            .then(function () {
            _this.navigating = false;
            if (navigationCanceled) {
                _this._events.next(new NavigationCancel());
                return;
            }
            // make sure queryParams changed before pushing to observable
            if (!isParamsEqual(_this.queryParamsSnapshot, _this.currentContext.queryParamsSnapshot)) {
                _this._queryParams.next(_this.currentContext.queryParamsSnapshot);
            }
            _this._events.next(new NavigationEnd(url, outlet.activatedComponent, _this.currentContext));
        })
            .catch(function (e) {
            _this.navigating = false;
            throw e;
        });
    };
    /**
     * @param {?} url
     * @param {?} config
     * @return {?}
     */
    Router.prototype.matchRoute = /**
     * @param {?} url
     * @param {?} config
     * @return {?}
     */
    function (url, config) {
        var _this = this;
        /** @type {?} */
        var path = UrlParser.parseUrl(url).pathname;
        if (!this.resolvedRoutes[path]) {
            return this.matchService.findRoute(url, config).then(function (route) {
                if (!route.noCache) {
                    _this.resolvedRoutes[path] = route;
                }
                return route;
            });
        }
        else {
            return Promise.resolve(this.resolvedRoutes[path]);
        }
    };
    /**
     * @param {?} url
     * @param {?} extras
     * @return {?}
     */
    Router.prototype.navigateInternal = /**
     * @param {?} url
     * @param {?} extras
     * @return {?}
     */
    function (url, extras) {
        /** @type {?} */
        var resolve = null;
        /** @type {?} */
        var reject = null;
        /** @type {?} */
        var result = new Promise(function (r, rej) {
            resolve = r;
            reject = rej;
        });
        this.scheduleNavigation({
            extras: extras,
            id: ++this.navigationId,
            promise: result,
            resolve: resolve,
            reject: reject,
            url: url
        });
        return result;
    };
    /**
     * @return {?}
     */
    Router.prototype.processNavigations = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.navigations.pipe(concatMap(function (nav) {
            if (nav) {
                return _this.executeScheduledNavigation(nav).then(nav.resolve, nav.reject);
            }
            else {
                return (/** @type {?} */ (of(null)));
            }
        })).subscribe(function () {
        });
        // initial query string
        /** @type {?} */
        var queryString = UrlParser.parseUrl(this.location.path(true)).search;
        this._queryParams = new BehaviorSubject(QueryStringParser.parse(queryString));
    };
    /**
     * @return {?}
     */
    Router.prototype.resetUrlToCurrent = /**
     * @return {?}
     */
    function () {
        if (this.currentContext) {
            this.location.replaceState(this.currentContext.url);
        }
    };
    /**
     * @param {?} originalUrl
     * @param {?} route
     * @return {?}
     */
    Router.prototype.resolveRoute = /**
     * @param {?} originalUrl
     * @param {?} route
     * @return {?}
     */
    function (originalUrl, route) {
        /** @type {?} */
        var urlParts = UrlParser.parseUrl(originalUrl);
        /** @type {?} */
        var queryParams = {};
        if (urlParts.search.length > 0) {
            // set url params to match its parsed state
            queryParams = QueryStringParser.parse(urlParts.search);
            /** @type {?} */
            var qs = QueryStringParser.serialize(queryParams);
            originalUrl = urlParts.pathname + (qs.length ? "?" + qs : "");
        }
        return {
            component: route.component,
            params: route.params,
            factoryResolver: route.factoryResolver,
            injector: route.injector || this.injector,
            route: route.route,
            queryParams: queryParams,
            url: originalUrl
        };
    };
    /**
     * @param {?} nav
     * @return {?}
     */
    Router.prototype.scheduleNavigation = /**
     * @param {?} nav
     * @return {?}
     */
    function (nav) {
        this.navigations.next(nav);
    };
    Router.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    Router.ctorParameters = function () { return [
        { type: RouterOutletMap },
        { type: RouteMatchService },
        { type: Location },
        { type: Injector },
        { type: String, decorators: [{ type: Optional }, { type: Inject, args: [APP_BASE_HREF,] }] }
    ]; };
    return Router;
}());
/**
 * @param {?} newRoute
 * @param {?} injector
 * @return {?}
 */
function checkActivate(newRoute, injector) {
    var e_2, _a;
    if (!newRoute.canActivate) {
        return Promise.resolve(true);
    }
    /** @type {?} */
    var results = [];
    try {
        for (var _b = __values(newRoute.canActivate), _c = _b.next(); !_c.done; _c = _b.next()) {
            var guardType = _c.value;
            /** @type {?} */
            var guard = (/** @type {?} */ (injector.get(guardType)));
            results.push(guard.canActivate(newRoute));
        }
    }
    catch (e_2_1) { e_2 = { error: e_2_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_2) throw e_2.error; }
    }
    return Promise.all(results).then(function (all) {
        return !all.some(function (r) { return !r; });
    });
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
var RouteContext = /** @class */ (function () {
    function RouteContext(url, resolvedRoute) {
        this._active = true;
        this.update(url, resolvedRoute);
    }
    Object.defineProperty(RouteContext.prototype, "queryParams", {
        get: /**
         * @return {?}
         */
        function () {
            return this._queryParams;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RouteContext.prototype, "outlet", {
        get: /**
         * @return {?}
         */
        function () {
            return this._route.outlet;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RouteContext.prototype, "routeParams", {
        get: /**
         * @return {?}
         */
        function () {
            return this._routeParams;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RouteContext.prototype, "url", {
        get: /**
         * @return {?}
         */
        function () {
            return this._url;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RouteContext.prototype, "route", {
        get: /**
         * @return {?}
         */
        function () {
            return this._route;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RouteContext.prototype, "injector", {
        get: /**
         * @return {?}
         */
        function () {
            return this._injector;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RouteContext.prototype, "active", {
        get: /**
         * @return {?}
         */
        function () {
            return this._active;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RouteContext.prototype, "queryParamsSnapshot", {
        get: /**
         * @return {?}
         */
        function () {
            return this._queryParams.getValue();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RouteContext.prototype, "routeParamsSnapshot", {
        get: /**
         * @return {?}
         */
        function () {
            return this._routeParams.getValue();
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    RouteContext.prototype.activate = /**
     * @return {?}
     */
    function () {
        this._active = true;
    };
    /**
     * @return {?}
     */
    RouteContext.prototype.deactivate = /**
     * @return {?}
     */
    function () {
        this._active = false;
    };
    /**
     * @param {?} url
     * @param {?} resolvedRoute
     * @return {?}
     */
    RouteContext.prototype.update = /**
     * @param {?} url
     * @param {?} resolvedRoute
     * @return {?}
     */
    function (url, resolvedRoute) {
        //try to keep urls consistent
        this._url = url[0] !== "/" ? "/" + url : url; // TODO: Base Href вместо / ??
        if (!this._queryParams) {
            this._queryParams = new BehaviorSubject(resolvedRoute.queryParams); // TODO query params ??
        }
        else if (!isParamsEqual(this.queryParamsSnapshot, resolvedRoute.queryParams)) {
            this._queryParams.next(resolvedRoute.queryParams); // TODO query params ??
        }
        if (!this._routeParams) {
            this._routeParams = new BehaviorSubject(resolvedRoute.params);
        }
        else if (!isParamsEqual(this.routeParamsSnapshot, resolvedRoute.params, true)) {
            this._routeParams.next(resolvedRoute.params);
        }
        this._route = resolvedRoute.route;
        this._injector = resolvedRoute.injector;
    };
    return RouteContext;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
var RouterScrollWrapper = /** @class */ (function () {
    function RouterScrollWrapper() {
    }
    /**
     * @return {?}
     */
    RouterScrollWrapper.prototype.getScrollState = /**
     * @return {?}
     */
    function () {
        return window.pageYOffset || document.documentElement.scrollTop;
    };
    /**
     * @param {?} position
     * @return {?}
     */
    RouterScrollWrapper.prototype.setScrollState = /**
     * @param {?} position
     * @return {?}
     */
    function (position) {
        window.scrollTo(0, position);
    };
    /**
     * @return {?}
     */
    RouterScrollWrapper.prototype.moveTop = /**
     * @return {?}
     */
    function () {
        this.setScrollState(0);
    };
    return RouterScrollWrapper;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
/** @type {?} */
var REUSE_CACHE_CONSTRAINT = new InjectionToken("Router reuse cache constraint");
var RouteReuseCache = /** @class */ (function () {
    function RouteReuseCache(router, constraint, location, scrollWrapper) {
        var _this = this;
        this.router = router;
        this.location = location;
        this.cache = window["_cache"] = [];
        this.newRouteNavigations = [];
        this.constraint = (/** @type {?} */ (constraint));
        if (location.getCurrentPageId) {
            router.events.subscribe(function (e) {
                if (e instanceof NavigationEnd && !e.routeContext.outlet) {
                    _this.currentCacheItem = _this.ensureCache(e.activatedComponent, e.routeContext);
                    if (!_this.lastRouteConfig || _this.lastRouteConfig !== e.routeContext.route) {
                        _this.newRouteNavigation();
                        _this.lastRouteConfig = e.routeContext.route;
                    }
                }
                else if (e instanceof NavigationStart) {
                    if (_this.currentCacheItem) {
                        _this.currentCacheItem.scrollState = scrollWrapper.getScrollState();
                    }
                }
            });
        }
        else {
            console.warn("Router will not reuse routes because your app use custom LocationStrategy which not provide information about page id");
        }
    }
    /**
     * @param {?} ref
     * @return {?}
     */
    RouteReuseCache.prototype.getCacheFor = /**
     * @param {?} ref
     * @return {?}
     */
    function (ref) {
        return this.cache.find(function (c) { return c.ref === ref; });
    };
    /**
     * @param {?} cmpType
     * @return {?}
     */
    RouteReuseCache.prototype.getForCurrentPage = /**
     * @param {?} cmpType
     * @return {?}
     */
    function (cmpType) {
        var e_1, _a;
        /** @type {?} */
        var cacheItems = this.cache.filter(function (c) { return c.ref.componentType === cmpType; });
        if (!cacheItems.length) {
            return undefined; // no cache
        }
        /** @type {?} */
        var pageId = this.getCurrentPageId();
        try {
            for (var cacheItems_1 = __values(cacheItems), cacheItems_1_1 = cacheItems_1.next(); !cacheItems_1_1.done; cacheItems_1_1 = cacheItems_1.next()) {
                var cacheItem = cacheItems_1_1.value;
                if (cacheItem.pageIds) {
                    //cache back
                    if (cacheItem.hasPageId(pageId)) {
                        return cacheItem;
                    }
                    continue;
                }
                return cacheItem; // sticky
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (cacheItems_1_1 && !cacheItems_1_1.done && (_a = cacheItems_1.return)) _a.call(cacheItems_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return undefined;
    };
    /**
     * @param {?} component
     * @param {?} routeCtx
     * @return {?}
     */
    RouteReuseCache.prototype.ensureCache = /**
     * @param {?} component
     * @param {?} routeCtx
     * @return {?}
     */
    function (component, routeCtx) {
        var e_2, _a;
        if (!component.instance.reuseRouteStrategy) {
            return undefined; // not a reusable component
        }
        // do not cache other outlets than default
        /** @type {?} */
        var cacheBack = component.instance.reuseRouteStrategy === ReuseRouteStrategy.CACHEBACK && !routeCtx.outlet;
        /** @type {?} */
        var pageId = this.getCurrentPageId();
        if (!pageId) {
            return undefined; // history api may not supoprted
        }
        /** @type {?} */
        var result;
        if (cacheBack) {
            /** @type {?} */
            var existCacheItems = this.cache.filter(function (c) { return c.ref.componentType === component.componentType; });
            try {
                for (var existCacheItems_1 = __values(existCacheItems), existCacheItems_1_1 = existCacheItems_1.next(); !existCacheItems_1_1.done; existCacheItems_1_1 = existCacheItems_1.next()) {
                    var cacheItem = existCacheItems_1_1.value;
                    if (cacheItem.ref.instance === component.instance) {
                        cacheItem.addPageId(pageId);
                        return cacheItem;
                    }
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (existCacheItems_1_1 && !existCacheItems_1_1.done && (_a = existCacheItems_1.return)) _a.call(existCacheItems_1);
                }
                finally { if (e_2) throw e_2.error; }
            }
            result = new ReuseCacheItem(component, routeCtx, pageId);
            this.cache.push(result);
        }
        else {
            /** @type {?} */
            var existsSticky = this.cache.some(function (c) { return c.ref.componentType === component.componentType; });
            if (!existsSticky) {
                result = new ReuseCacheItem(component, routeCtx);
                this.cache.push(result);
            }
        }
        return result;
    };
    /**
     * @return {?}
     */
    RouteReuseCache.prototype.getCurrentPageId = /**
     * @return {?}
     */
    function () {
        return this.location.getCurrentPageId();
    };
    /**
     * @return {?}
     */
    RouteReuseCache.prototype.newRouteNavigation = /**
     * @return {?}
     */
    function () {
        // removes cache which out of constraint
        var e_3, _a, e_4, _b;
        this.newRouteNavigations.push(this.getCurrentPageId());
        if (this.newRouteNavigations.length > this.constraint.maxHistoryCacheDepth + 1 /* include current navigation */) {
            this.newRouteNavigations.shift();
        }
        /** @type {?} */
        var cacheItemsToDrop = [];
        /** @type {?} */
        var stickyRoutesUsed = 0;
        var _loop_1 = function (cacheItem) {
            // do not clear cacheback for all other outlets
            if (cacheItem.reuseStrategy === ReuseRouteStrategy.CACHEBACK && !cacheItem.routeContext.outlet) {
                if (this_1.newRouteNavigations.every(function (n) { return !cacheItem.hasPageId(n); })) {
                    cacheItemsToDrop.push(cacheItem);
                }
            }
            else {
                stickyRoutesUsed++;
                if (stickyRoutesUsed > this_1.constraint.maxStickyRoutes) {
                    cacheItemsToDrop.push(cacheItem);
                }
            }
        };
        var this_1 = this;
        try {
            for (var _c = __values(this.cache), _d = _c.next(); !_d.done; _d = _c.next()) {
                var cacheItem = _d.value;
                _loop_1(cacheItem);
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
            }
            finally { if (e_3) throw e_3.error; }
        }
        try {
            for (var cacheItemsToDrop_1 = __values(cacheItemsToDrop), cacheItemsToDrop_1_1 = cacheItemsToDrop_1.next(); !cacheItemsToDrop_1_1.done; cacheItemsToDrop_1_1 = cacheItemsToDrop_1.next()) {
                var cacheToDrop = cacheItemsToDrop_1_1.value;
                cacheToDrop.destroy();
                this.cache.splice(this.cache.indexOf(cacheToDrop), 1);
            }
        }
        catch (e_4_1) { e_4 = { error: e_4_1 }; }
        finally {
            try {
                if (cacheItemsToDrop_1_1 && !cacheItemsToDrop_1_1.done && (_b = cacheItemsToDrop_1.return)) _b.call(cacheItemsToDrop_1);
            }
            finally { if (e_4) throw e_4.error; }
        }
    };
    RouteReuseCache.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    RouteReuseCache.ctorParameters = function () { return [
        { type: Router },
        { type: undefined, decorators: [{ type: Inject, args: [REUSE_CACHE_CONSTRAINT,] }] },
        { type: undefined, decorators: [{ type: Inject, args: [LocationStrategy,] }] },
        { type: RouterScrollWrapper }
    ]; };
    return RouteReuseCache;
}());
var ReuseCacheItem = /** @class */ (function () {
    function ReuseCacheItem(ref, routeCtx, pageId) {
        if (pageId) {
            this._pageIds = [pageId];
        }
        this._ref = ref;
        this._routeCtx = routeCtx;
    }
    Object.defineProperty(ReuseCacheItem.prototype, "pageIds", {
        /**
         * Cached within specified pageIds
         */
        get: /**
         * Cached within specified pageIds
         * @return {?}
         */
        function () {
            return this._pageIds;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ReuseCacheItem.prototype, "ref", {
        /**
         * Cached component reference
         */
        get: /**
         * Cached component reference
         * @return {?}
         */
        function () {
            return this._ref;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ReuseCacheItem.prototype, "routeContext", {
        get: /**
         * @return {?}
         */
        function () {
            return this._routeCtx;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ReuseCacheItem.prototype, "reuseStrategy", {
        get: /**
         * @return {?}
         */
        function () {
            return this._ref.instance.reuseRouteStrategy;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} pageId
     * @return {?}
     */
    ReuseCacheItem.prototype.addPageId = /**
     * @param {?} pageId
     * @return {?}
     */
    function (pageId) {
        if (!this._ref) {
            throw new Error("Route cache item was destroyed");
        }
        if (!this._pageIds) {
            this._pageIds = [];
        }
        if (this.hasPageId(pageId)) {
            return;
        }
        this._pageIds.push(pageId);
    };
    /**
     * @return {?}
     */
    ReuseCacheItem.prototype.attached = /**
     * @return {?}
     */
    function () {
        if (!this._ref) {
            throw new Error("Route cache item was destroyed");
        }
        if (this.ref.instance.onRouteReused) {
            this.ref.instance.onRouteReused();
        }
        this.routeContext.activate();
    };
    /**
     * @return {?}
     */
    ReuseCacheItem.prototype.destroy = /**
     * @return {?}
     */
    function () {
        if (this._ref) {
            this._ref.destroy();
            this._ref = null;
        }
    };
    /**
     * @return {?}
     */
    ReuseCacheItem.prototype.detached = /**
     * @return {?}
     */
    function () {
        if (!this._ref) {
            throw new Error("Route cache item was destroyed");
        }
        if (this.ref.instance.onRouteCached) {
            this.ref.instance.onRouteCached();
        }
        this.routeContext.deactivate();
    };
    /**
     * @param {?} pageId
     * @return {?}
     */
    ReuseCacheItem.prototype.hasPageId = /**
     * @param {?} pageId
     * @return {?}
     */
    function (pageId) {
        if (!this._pageIds) {
            return false;
        }
        return this._pageIds.indexOf(pageId) >= 0;
    };
    return ReuseCacheItem;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
var RouterExOutletComponent = /** @class */ (function () {
    function RouterExOutletComponent(parentOutletMap, location, reuseCache, scrollWrapper, name) {
        this.parentOutletMap = parentOutletMap;
        this.location = location;
        this.reuseCache = reuseCache;
        this.scrollWrapper = scrollWrapper;
        this.name = name;
        this.prerenderFallback = 500;
        this.activateEvents = new EventEmitter();
        this.deactivateEvents = new EventEmitter();
        this.prerenderReadyEvents = new EventEmitter();
        parentOutletMap.register((/** @type {?} */ (this)), name);
    }
    Object.defineProperty(RouterExOutletComponent.prototype, "isActivated", {
        get: /**
         * @return {?}
         */
        function () {
            return !!this.activated;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RouterExOutletComponent.prototype, "activatedComponent", {
        get: /**
         * @return {?}
         */
        function () {
            return this.activated;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} route
     * @param {?} url
     * @param {?} componentType
     * @param {?} resolver
     * @param {?} injector
     * @param {?=} force
     * @return {?}
     */
    RouterExOutletComponent.prototype.activate = /**
     * @param {?} route
     * @param {?} url
     * @param {?} componentType
     * @param {?} resolver
     * @param {?} injector
     * @param {?=} force
     * @return {?}
     */
    function (route, url, componentType, resolver, injector, force) {
        var _this = this;
        if (!force && this.routeCtx && routeEquals(this.routeCtx.route, route.route)) {
            this.routeCtx.update(url, route);
            return Promise.resolve({ routeContext: this.routeCtx });
        }
        /** @type {?} */
        var cache = this.reuseCache.getForCurrentPage(componentType);
        if (cache) {
            // reuse existing component ref
            this.activateComponent(cache.ref, cache.routeContext);
            cache.attached();
            cache.ref.changeDetectorRef.detectChanges();
            if (cache.reuseStrategy === ReuseRouteStrategy.CACHEBACK) {
                this.scrollWrapper.setScrollState(cache.scrollState);
            }
            cache.routeContext.update(url, route);
            return Promise.resolve({
                routeContext: cache.routeContext
            });
        }
        /** @type {?} */
        var routeContext = new RouteContext(url, route);
        // create new instance of the component
        /** @type {?} */
        var factory = resolver.resolveComponentFactory(componentType);
        /** @type {?} */
        var inj = Injector.create([
            { provide: RouteContext, useValue: routeContext }
        ], injector);
        //const inj = bindings.get(RouteContext)//= ReflectiveInjector.fromResolvedProviders(bindings, injector);
        /** @type {?} */
        var componentToActivate = this.prerenderContainer.createComponent(factory, this.prerenderContainer.length, inj, []);
        /** @type {?} */
        var onDone = function () {
            if (_this.autoScroll) {
                _this.scrollWrapper.moveTop();
            }
        };
        /** @type {?} */
        var noPrerender = function () {
            // no prerender
            _this.prerenderContainer.detach();
            _this.activateComponent(componentToActivate, routeContext);
            onDone();
            return Promise.resolve({
                routeContext: routeContext
            });
        };
        // need to prerender component ?
        /** @type {?} */
        var prerenderComponent = (/** @type {?} */ (componentToActivate.instance));
        if (prerenderComponent.routePrerender) {
            /** @type {?} */
            var rendered_1 = false;
            /** @type {?} */
            var routeReady_1 = ((/** @type {?} */ (componentToActivate.instance)))
                .routePrerender()
                .then(function () {
                _this.prerenderReadyEvents.emit(componentToActivate);
            }, function (err) {
                _this.prerenderReadyEvents.emit(componentToActivate);
                throw err;
            });
            if (this.activatedComponent) {
                return new Promise(function (resolve) {
                    /** @type {?} */
                    var delay$ = of(true)
                        .pipe(delay(prerenderComponent.fallbackTimeout || _this.prerenderFallback));
                    from(routeReady_1)
                        .pipe(merge(delay$))
                        .subscribe(function () {
                        if (rendered_1) {
                            return;
                        }
                        rendered_1 = true;
                        _this.prerenderContainer.detach();
                        _this.activateComponent(componentToActivate, routeContext);
                        onDone();
                        resolve({ routeContext: routeContext });
                    });
                });
            }
            else {
                return noPrerender();
            }
        }
        else {
            return noPrerender();
        }
    };
    /**
     * @return {?}
     */
    RouterExOutletComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.parentOutletMap.unregister(this.name);
    };
    /**
     * Replace current activated component with specified one
     */
    /**
     * Replace current activated component with specified one
     * @param {?} ref
     * @param {?} routeCtx
     * @return {?}
     */
    RouterExOutletComponent.prototype.activateComponent = /**
     * Replace current activated component with specified one
     * @param {?} ref
     * @param {?} routeCtx
     * @return {?}
     */
    function (ref, routeCtx) {
        this.deactivateCurrent();
        this.attach(ref, routeCtx);
        this.activateEvents.emit(this.activated.instance);
        if (ref.instance.onRouteOutletActivated) {
            ref.instance.onRouteOutletActivated();
        }
    };
    /**
     * @param {?} ref
     * @param {?} routeContext
     * @return {?}
     */
    RouterExOutletComponent.prototype.attach = /**
     * @param {?} ref
     * @param {?} routeContext
     * @return {?}
     */
    function (ref, routeContext) {
        this.activated = ref;
        this.routeCtx = routeContext;
        this.location.insert(ref.hostView);
    };
    /**
     * @return {?}
     */
    RouterExOutletComponent.prototype.deactivateCurrent = /**
     * @return {?}
     */
    function () {
        if (this.activated) {
            /** @type {?} */
            var c = this.activated.instance;
            /** @type {?} */
            var cache = this.reuseCache.getCacheFor(this.activated);
            if (this.activated.instance.onRouteOutletDeactivated) {
                this.activated.instance.onRouteOutletDeactivated();
            }
            if (cache) {
                this.location.detach();
                cache.detached();
            }
            else {
                this.activated.destroy();
            }
            this.activated = null;
            this.deactivateEvents.emit(c);
        }
    };
    RouterExOutletComponent.decorators = [
        { type: Component, args: [{
                    selector: "router-ex-outlet",
                    template: "\n        <div #placeholder></div>",
                    styles: [":host {\n        display: none;\n    }"]
                }] }
    ];
    /** @nocollapse */
    RouterExOutletComponent.ctorParameters = function () { return [
        { type: RouterOutletMap },
        { type: ViewContainerRef },
        { type: RouteReuseCache },
        { type: RouterScrollWrapper },
        { type: String, decorators: [{ type: Attribute, args: ["name",] }] }
    ]; };
    RouterExOutletComponent.propDecorators = {
        autoScroll: [{ type: Input }],
        prerenderFallback: [{ type: Input }],
        activateEvents: [{ type: Output, args: ["onActivate",] }],
        deactivateEvents: [{ type: Output, args: ["onDeactivate",] }],
        prerenderReadyEvents: [{ type: Output, args: ["prerenderReady",] }],
        prerenderContainer: [{ type: ViewChild, args: ["placeholder", { read: ViewContainerRef },] }]
    };
    return RouterExOutletComponent;
}());
/**
 * @param {?} route
 * @param {?} route2
 * @return {?}
 */
function routeEquals(route, route2) {
    return route.path === route2.path;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
/**
 * Intercept all document click on anchor href and perform router navigation
 */
var HandleHrefNavigationDirective = /** @class */ (function () {
    function HandleHrefNavigationDirective(router) {
        var _this = this;
        this.router = router;
        this.handler = function (event) {
            /*
             *  Взято из первого ангуляра
             */
            if (event.defaultPrevented) {
                return;
            }
            /* открытие в новом окне и т.п. не обрабатываем */
            if (event.ctrlKey || event.metaKey || event.shiftKey || event.which === 2 || event.button === 2)
                return;
            /** @type {?} */
            var elm = (/** @type {?} */ (event.target));
            // traverse the DOM up to find first A tag
            while (!elm.nodeName || elm.nodeName.toUpperCase() !== "A") {
                // ignore rewriting if no A tag (reached root element, or no parent - removed from document)
                if (elm === document.body || !(elm = elm.parentElement))
                    return;
            }
            /** @type {?} */
            var navigateUrl = elm.getAttribute("href");
            /* не обрабатываем пустые ссылки,
             ссылки, открывающиеся в новом окне,
             ссылки на внешние ресурсы, а также ссылки с url-scheme приложений и на внешние url*/
            if (navigateUrl &&
                (elm.getAttribute("target") === "_blank" || /^\s*(javascript|mailto|tel|sip):/i.test(navigateUrl)) ||
                HandleHrefNavigationDirective.isExternalNavigation(navigateUrl)) {
                return;
            }
            event.preventDefault();
            if (navigateUrl) {
                _this.router.navigateByUrl(navigateUrl);
            }
        };
    }
    /**
     * @return {?}
     */
    HandleHrefNavigationDirective.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        document.body.addEventListener("click", this.handler);
    };
    /**
     * @return {?}
     */
    HandleHrefNavigationDirective.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        document.body.removeEventListener("click", this.handler);
    };
    /**
     * @param {?} url
     * @return {?}
     */
    HandleHrefNavigationDirective.isExternalNavigation = /**
     * @param {?} url
     * @return {?}
     */
    function (url) {
        /** @type {?} */
        var parsed = UrlParser.parseUrl(url);
        return isAbsUrl(url) && window.location.host !== parsed.host;
    };
    HandleHrefNavigationDirective.decorators = [
        { type: Directive, args: [{
                    selector: "[handleHrefNavigation]"
                },] }
    ];
    /** @nocollapse */
    HandleHrefNavigationDirective.ctorParameters = function () { return [
        { type: Router }
    ]; };
    return HandleHrefNavigationDirective;
}());
/**
 * @param {?} url
 * @return {?}
 */
function isAbsUrl(url) {
    if (!url) {
        return false;
    }
    return (url.indexOf("https://") === 0 || url.indexOf("http://") === 0 || url.indexOf("//") === 0);
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
/**
 * Состояние, которое сохраняется в HISTORY STATE
 *
 * \@property {boolean} pageId Уникальный идентификатор страницы в истории браузера
 */
var /**
 * Состояние, которое сохраняется в HISTORY STATE
 *
 * \@property {boolean} pageId Уникальный идентификатор страницы в истории браузера
 */
HistoryPageState = /** @class */ (function () {
    function HistoryPageState(pageId) {
        this.pageId = pageId;
    }
    /**
     * Создает новое состояние с уникальным pageID
     */
    /**
     * Создает новое состояние с уникальным pageID
     * @return {?}
     */
    HistoryPageState.createNew = /**
     * Создает новое состояние с уникальным pageID
     * @return {?}
     */
    function () {
        return new HistoryPageState(generateUniqueId());
    };
    return HistoryPageState;
}());
var HistoryApiLocationStrategy = /** @class */ (function (_super) {
    __extends(HistoryApiLocationStrategy, _super);
    function HistoryApiLocationStrategy(_platformLocation, href) {
        var _this = _super.call(this) || this;
        _this._platformLocation = _platformLocation;
        if (href == null) {
            href = _this._platformLocation.getBaseHrefFromDOM();
        }
        if (href == null) {
            console.warn("No base href set. Please provide a value for the APP_BASE_HREF token or add a base element to the document.");
            href = "/"; // TODO BUG после обновления до 4.0.0-rc.4 почему то перестал инджектится APP_BASE_HREF
        }
        _this._baseHref = href;
        return _this;
    }
    /**
     * @return {?}
     */
    HistoryApiLocationStrategy.prototype.getCurrentPageId = /**
     * @return {?}
     */
    function () {
        return history.state ? history.state.pageId : undefined;
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    HistoryApiLocationStrategy.prototype.onPopState = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this._platformLocation.onPopState(fn);
        this._platformLocation.onHashChange(fn);
    };
    /**
     * @return {?}
     */
    HistoryApiLocationStrategy.prototype.getBaseHref = /**
     * @return {?}
     */
    function () {
        return this._baseHref;
    };
    /**
     * @param {?} internal
     * @return {?}
     */
    HistoryApiLocationStrategy.prototype.prepareExternalUrl = /**
     * @param {?} internal
     * @return {?}
     */
    function (internal) {
        return Location.joinWithSlash(this._baseHref, internal);
    };
    /**
     * @param {?=} includeHash
     * @return {?}
     */
    HistoryApiLocationStrategy.prototype.path = /**
     * @param {?=} includeHash
     * @return {?}
     */
    function (includeHash) {
        if (includeHash === void 0) { includeHash = false; }
        /** @type {?} */
        var pathname = this._platformLocation.pathname +
            Location.normalizeQueryParams(this._platformLocation.search);
        /** @type {?} */
        var hash = this._platformLocation.hash;
        return hash && includeHash ? "" + pathname + hash : pathname;
    };
    /**
     * @param {?} state
     * @param {?} title
     * @param {?} url
     * @param {?} queryParams
     * @return {?}
     */
    HistoryApiLocationStrategy.prototype.pushState = /**
     * @param {?} state
     * @param {?} title
     * @param {?} url
     * @param {?} queryParams
     * @return {?}
     */
    function (state, title, url, queryParams) {
        /** @type {?} */
        var externalUrl = this.prepareExternalUrl(url + Location.normalizeQueryParams(queryParams));
        this._platformLocation.pushState(HistoryPageState.createNew(), title, externalUrl);
        //resetPopedState();
    };
    /**
     * @param {?} state
     * @param {?} title
     * @param {?} url
     * @param {?} queryParams
     * @return {?}
     */
    HistoryApiLocationStrategy.prototype.replaceState = /**
     * @param {?} state
     * @param {?} title
     * @param {?} url
     * @param {?} queryParams
     * @return {?}
     */
    function (state, title, url, queryParams) {
        /** @type {?} */
        var externalUrl = this.prepareExternalUrl(url + Location.normalizeQueryParams(queryParams));
        this._platformLocation.replaceState(ensureHistoryState(), title, externalUrl);
        //resetPopedState();
    };
    /**
     * @return {?}
     */
    HistoryApiLocationStrategy.prototype.forward = /**
     * @return {?}
     */
    function () {
        this._platformLocation.forward();
    };
    /**
     * @return {?}
     */
    HistoryApiLocationStrategy.prototype.back = /**
     * @return {?}
     */
    function () {
        this._platformLocation.back();
    };
    HistoryApiLocationStrategy.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    HistoryApiLocationStrategy.ctorParameters = function () { return [
        { type: PlatformLocation },
        { type: String, decorators: [{ type: Optional }, { type: Inject, args: [APP_BASE_HREF,] }] }
    ]; };
    return HistoryApiLocationStrategy;
}(LocationStrategy));
/**
 * @param {?=} state
 * @return {?}
 */
function ensureHistoryState(state) {
    /** @type {?} */
    var currentState = state || window.history.state;
    if (!currentState) {
        currentState = HistoryPageState.createNew();
    }
    return currentState;
}
/**
 * @return {?}
 */
function generateUniqueId() {
    /** @type {?} */
    var idstr = String.fromCharCode(Math.floor((Math.random() * 25) + 65));
    do {
        // between numbers and characters (48 is 0 and 90 is Z (42-48 = 90)
        /** @type {?} */
        var ascicode = Math.floor((Math.random() * 42) + 48);
        if (ascicode < 58 || ascicode > 64) {
            // exclude all chars between : (58) and @ (64)
            idstr += String.fromCharCode(ascicode);
        }
    } while (idstr.length < 5);
    return idstr;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
/** @type {?} */
var DEFAULT_CACHE_CONSTRAINT = { maxStickyRoutes: 2, maxHistoryCacheDepth: 1 };
var RouterExModule = /** @class */ (function () {
    function RouterExModule() {
    }
    /**
     * @param {?} routeConfig
     * @return {?}
     */
    RouterExModule.forRoot = /**
     * @param {?} routeConfig
     * @return {?}
     */
    function (routeConfig) {
        return {
            ngModule: RouterExModule,
            providers: [
                Location,
                RouterOutletMap,
                RouteMatchService,
                Router,
                RouteReuseCache,
                RouterScrollWrapper,
                { provide: RouterModuleFactory, useClass: DefaultRouterModuleFactory },
                { provide: ANALYZE_FOR_ENTRY_COMPONENTS, multi: true, useValue: routeConfig },
                { provide: NgModuleFactoryLoader, useClass: SystemJsNgModuleLoader },
                { provide: LocationStrategy, useClass: HistoryApiLocationStrategy },
                { provide: ROUTE_CONFIG, useValue: routeConfig },
                {
                    provide: REUSE_CACHE_CONSTRAINT,
                    useValue: DEFAULT_CACHE_CONSTRAINT
                },
                {
                    provide: APP_BOOTSTRAP_LISTENER, multi: true, useFactory: initialRouterNavigation,
                    deps: [Router, ApplicationRef]
                }
            ]
        };
    };
    /**
     * @param {?} routeConfig
     * @return {?}
     */
    RouterExModule.forChild = /**
     * @param {?} routeConfig
     * @return {?}
     */
    function (routeConfig) {
        return {
            ngModule: RouterExModule,
            providers: [
                { provide: ROUTE_CONFIG, useValue: routeConfig },
                { provide: ANALYZE_FOR_ENTRY_COMPONENTS, multi: true, useValue: routeConfig },
            ]
        };
    };
    RouterExModule.decorators = [
        { type: NgModule, args: [{
                    exports: [
                        RouterExOutletComponent,
                        HandleHrefNavigationDirective
                    ],
                    declarations: [
                        RouterExOutletComponent,
                        HandleHrefNavigationDirective
                    ],
                    providers: [
                        QueryStringParser
                    ],
                    imports: [
                        CommonModule
                    ]
                },] }
    ];
    return RouterExModule;
}());
/**
 * @param {?} router
 * @param {?} ref
 * @return {?}
 */
function initialRouterNavigation(router, ref) {
    /**
     * @param {?} bootstrappedComponentRef
     * @return {?}
     */
    function initNav(bootstrappedComponentRef) {
        if (bootstrappedComponentRef !== ref.components[0]) {
            return;
        }
        router.initialNavigation();
    }
    return initNav;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */

export { Router, RouterOutletMap, ReuseRouteStrategy, RouterExModule, NavigationCancel, NavigationEnd, NavigationStart, RouteContext, RouterModuleFactory, UrlParser, ROUTE_CONFIG as ɵa, HistoryApiLocationStrategy as ɵi, QueryStringParser as ɵl, RouteMatchService as ɵd, REUSE_CACHE_CONSTRAINT as ɵf, RouteReuseCache as ɵg, DefaultRouterModuleFactory as ɵc, RouterScrollWrapper as ɵj, HandleHrefNavigationDirective as ɵk, RouterExOutletComponent as ɵe, initialRouterNavigation as ɵb };

//# sourceMappingURL=angular-router-ex.js.map